#
from enigma import *
from Screens.Standby import TryQuitMainloop
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ScrollLabel import ScrollLabel
from Components.GUIComponent import *
from Components.MenuList import MenuList
from Components.Input import Input
from Screens.Console import Console
from Plugins.Plugin import PluginDescriptor
from Screens.ImageWizard import ImageWizard
from Screens.ServiceInfo import *
from Plugins.Plugin import PluginDescriptor

import os

from time import *
import time
import datetime

morpheus_pluginversion = "2.0"
timeoutfile="/etc/init.d/.screensavertimeout"
coloursfile="/etc/init.d/.screensavercolours"
deepstandbyfile="/etc/init.d/.screensaverdeepstandby"

###############################################################################

def autostart(reason, **kwargs):
        pass
        if "session" in kwargs:
           DoMorpheus(kwargs["session"])

def Plugins(**kwargs):
	return [PluginDescriptor(where = [PluginDescriptor.WHERE_SESSIONSTART, PluginDescriptor.WHERE_AUTOSTART], fnc = autostart),PluginDescriptor(name="Morpheus Screensaver", description="Screensaver Plugin", where = PluginDescriptor.WHERE_PLUGINMENU, icon="morpheus.png", fnc=main)]

def main(session, **kwargs):
    session.open(Morpheus)

###############################################################################

class Morpheus(Screen):
    skin = """
        <screen position="180,200" size="390,280" title="Morpheus Screensaver" >
            <widget name="menu" position="10,10" size="380,270" scrollbarMode="showOnDemand" />
        </screen>"""
        
    def __init__(self, session, args = 0):
        self.skin = Morpheus.skin
        self.session = session
      
        Screen.__init__(self, session)
     
        self.menu = args

        list = []

        list.append((_("Check Screensaver daemon"), "morpheuscheck"))        
        list.append((_("Start Scrensaver daemon"), "morpheusstart"))        
        list.append((_("Stop Scrensaver daemon"), "morpheusstop"))        
        list.append((_("Disable Screensaver daemon"), "morpheusdisable"))        
        list.append((_("Enable Screensaver daemon"), "morpheusenable"))        
        list.append((_("Change Screensaver Timeout"), "morpheustimeout"))        
        list.append((_("Change Screensaver Colours"), "morpheuscolours"))        
        list.append((_("Change Standbytime for Deepstandby"), "morpheusdeepstandby"))        
        list.append((_("about"), "about"))        
        self["menu"] = MenuList(list)
        self["actions"] = ActionMap(["WizardActions", "DirectionActions"],{"ok": self.go,"back": self.close,}, -1)
        
    def go(self):
        returnValue = self["menu"].l.getCurrentSelection()[1]
        if returnValue is not None:
           if returnValue is "morpheusenable":
	      if os.path.exists("/etc/rc3.d/S99screensaver") is False:
                 os.symlink("/etc/init.d/morpheus","/etc/rc3.d/S99screensaver")
                 self.session.open(Console,_("starting screensaver deamen because enabled"),["/etc/init.d/morpheus start"])
              else:
                 self.session.open(MessageBox,_("Screensaver daemon already enabled"), MessageBox.TYPE_WARNING)
           elif returnValue is "morpheusdisable":
	      if os.path.exists("/etc/rc3.d/S99screensaver") is True:
                 os.remove("/etc/rc3.d/S99screensaver")
                 self.session.open(Console,_("stopping screensaver daemon because disabled"),["/etc/init.d/morpheus stop"])
              else:
                 self.session.open(MessageBox,_("Screensaver daemon already disabled"), MessageBox.TYPE_WARNING)
           elif returnValue is "morpheuscheck":
              self.session.open(Console,_("checking screensaver dameon"),["/etc/init.d/morpheus check"])
           elif returnValue is "morpheusstart":
              self.session.open(Console,_("starting screensaver dameon"),["/etc/init.d/morpheus start"])
           elif returnValue is "morpheusstop":
              self.session.open(Console,_("stopping screensaver dameon"),["/etc/init.d/morpheus stop"])
           elif returnValue is "morpheustimeout":
              self.session.openWithCallback(self.askForMorpheusTimeout,ChoiceBox,_("Choose Screensaver timeout"),self.getTimeoutList())        
           elif returnValue is "morpheuscolours":
              self.session.openWithCallback(self.askForMorpheusColours,ChoiceBox,_("Choose Screensaver colours"),self.getColoursList())        
           elif returnValue is "morpheusdeepstandby":
              self.session.openWithCallback(self.askForMorpheusDeepstandby,ChoiceBox,_("Choose time in Standby for Deepstandby"),self.getDeepstandbyList())        
           elif returnValue is "about":
              self.session.open(MessageBox,_("Morpheus Screensaver Plugin\nVersion %s by gutemine" % morpheus_pluginversion), MessageBox.TYPE_INFO)


    def askForMorpheusTimeout(self,timeout):
        if timeout is None:
            self.skipMorpheus(_("no timeout entered"))
        else:
            self.timeout = timeout[1]
            self.session.openWithCallback(self.DoMorpheusTimeout,MessageBox,_("sure to set timeout to %s min ?" % self.timeout), MessageBox.TYPE_YESNO)
            
    def DoMorpheusTimeout(self,answer):
        if answer is None:
            self.skipMorpheus(_("nothing choosen"))
        elif answer is False:
            self.skipMorpheus(_("you were not confirming"))
        else:
            tf = open(timeoutfile,"w+")
            tf.write("%s\n" % self.timeout)
            tf.close()
            self.session.open(Console,_("restarting screensaver dameon"),["/etc/init.d/morpheus restart"])
            
    def askForMorpheusColours(self,colours):
        if colours is None:
            self.skipMorpheus(_("no colours entered"))
        else:
            self.colours = colours[1]
            self.session.openWithCallback(self.DoMorpheusColours,MessageBox,_("sure to set colours to %s ?" % self.colours), MessageBox.TYPE_YESNO)
            
    def DoMorpheusColours(self,answer):
        if answer is None:
            self.skipTimeout(_("nothing choosen"))
        elif answer is False:
            self.skipTimeout(_("you were not confirming"))
        else:
            cf = open(coloursfile,"w+")
            cf.write("%s\n" % self.colours)
            cf.close()
            self.session.open(Console,_("restarting screensaver dameon"),["/etc/init.d/morpheus restart"])
            
    def askForMorpheusDeepstandby(self,deepstandby):
        if deepstandby is None:
            self.skipMorpheus(_("no deepstandby entered"))
        else:
            self.deepstandby = deepstandby[1]
            self.session.openWithCallback(self.DoMorpheusDeepstandby,MessageBox,_("sure to set deepstandby to %s min ?" % self.deepstandby), MessageBox.TYPE_YESNO)
            
    def DoMorpheusDeepstandby(self,answer):
        if answer is None:
            self.skipMorpheus(_("nothing choosen"))
        elif answer is False:
            self.skipMorpheus(_("you were not confirming"))
        else:
            df = open(deepstandbyfile,"w+")
            df.write("%s\n" % self.deepstandby)
            df.close()
            self.session.open(Console,_("restarting screensaver dameon"),["/etc/init.d/morpheus restart"])
            
    def skipMorpheus(self,reason):
        self.session.open(MessageBox,_("Screensaver setup was canceled, because %s") % reason, MessageBox.TYPE_WARNING)
        
        
    def getTimeoutList(self):
        timeouts = []
        timeouts.append((_("5  min"),"5"))
        timeouts.append((_("10  min"),"10"))
        timeouts.append((_("15  min"),"15"))
        timeouts.append((_("30  min"),"30"))
        timeouts.append((_("60  min"),"60"))
        timeouts.append((_("90  min"),"90"))
        timeouts.append((_("120 min"),"120"))
        return timeouts
        
    def getColoursList(self):
        colours = []
        colours.append((_("1: black"),"1"))
        colours.append((_("2: black white"),"2"))
        colours.append((_("3: black white red"),"3"))
        colours.append((_("4: black white red green"),"4"))
        colours.append((_("5: black white red green blue"),"5"))
        colours.append((_("6: black white red green blue yellow"),"6"))
        return colours

    def getDeepstandbyList(self):
        deepstandby = []
        deepstandby.append((_("disabled"),"0"))
        deepstandby.append((_("30  min"),"30"))
        deepstandby.append((_("60  min"),"60"))
        deepstandby.append((_("120 min"),"120"))
        deepstandby.append((_("180 min"),"180"))
        deepstandby.append((_("240 min"),"240"))
        deepstandby.append((_("480 min"),"480"))
        return deepstandby
        


class DoMorpheus(Screen):
	def __init__(self,session):
		Screen.__init__(self,session)

		self.session = session
                
                self.morpheus_fb_locked=0;

                if os.path.exists("/etc/rc3.d/S99screensaver") == True:
                   print "[MORPHEUS] restarting screensaver"
                   os.system("/etc/init.d/morpheus restart")
	
		self.TimerMorpheus = eTimer()
		self.TimerMorpheus.stop()
		self.TimerMorpheus.timeout.get().append(self.CheckMorpheus)
		self.TimerMorpheus.start(3000,True) 
		
			
	def CheckMorpheus(self):

                if os.path.exists("/tmp/.screensaver") == True:
#                  os.system("wall screensaver")
		   fbClass.getInstance().lock()
                   self.morpheus_fb_locked=1;
                else:
#                  os.system("wall noscreensaver")
                   if self.morpheus_fb_locked == 1:
		      fbClass.getInstance().unlock()
                      self.morpheus_fb_locked=0
                      self.session.open(MessageBox,_("Morpheus Screensaver ended !\nVersion %s by gutemine" % morpheus_pluginversion), MessageBox.TYPE_INFO, timeout=2)
                   else:
                      pass

		self.TimerMorpheus = eTimer()
		self.TimerMorpheus.stop()
		self.TimerMorpheus.timeout.get().append(self.CheckMorpheus)
		self.TimerMorpheus.start(3000,True) 
		
